<?php
// +-----------------------------------------------------------------------+
// | Piwigo - a PHP based picture gallery                                  |
// +-----------------------------------------------------------------------+
// | Copyright(C) 2008-2009 Piwigo Team                  http://piwigo.org |
// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

if (!defined('PHPWG_ROOT_PATH'))
{
  die('Hacking attempt!');
}


load_language('plugin.lang', MAIL_SUPERV_PATH);
include_once(PHPWG_ROOT_PATH.'include/functions_mail.inc.php');
global $period_search,$period_match ;
	$period_search=array("D","H","M","S","W");
	array_push($period_search,l10n('Week'),l10n('Day'),l10n('Hour'),l10n('Minute'),l10n('Seconde'));
	
	$period_match=array(" day"," hour"," minute"," second"," week");	
	array_push($period_match,'week','day','hour','minute','seconde');

function sauve_options()
{
global $mails_options ;
	$query = '
    UPDATE '.CONFIG_TABLE.'
    SET value="'.$mails_options[0]. ',' .$mails_options[1]. ',' .$mails_options[2].',' .$mails_options[3]. ',' .$mails_options[4]. '"
    WHERE param="mail_superv"
    LIMIT 1';
 pwg_query($query);

}
//=================================================================================
function sauve_donnes()
{
global $mails_donnes ;

$query = '
        UPDATE '.MAIL_SUPERV_TABLE.'
        SET `nb_mails`         = '.$mails_donnes['nb_mails'].',
			`date_mail`        = '.$mails_donnes['date_mail'].',
			`nb_mails_maxi`    = '.$mails_donnes['nb_mails_maxi'].',	
			`nb_mails_periode`    = "'.$mails_donnes['nb_mails_periode'].'",	
					
			`nb_spams`         = '.$mails_donnes['nb_spams'].',
			`date_spam`        = '.$mails_donnes['date_spam'].',
			`nb_spams_maxi`    = '.$mails_donnes['nb_spams_maxi'].',	
			`nb_spams_periode`    = "'.$mails_donnes['nb_spams_periode'].'",	
								
			`quarantaine`      = "'.$mails_donnes['quarantaine'].'",
			`date_quarantaine` = '.$mails_donnes['date_quarantaine'].',
			
			`quarantaine_periode`    = "'.$mails_donnes['quarantaine_periode'].'",				
			
			`message`          = "'.$mails_donnes['message'].'",
			`header_text`      = "'.$mails_donnes['header_text'].'"
		WHERE `id` =1 LIMIT 1 ';
		

      pwg_query($query);


}
//=================================================================================
function affiche_message()
{
 global $template,$infos_message,$erreur_message ;;
  
  if (isset($erreur_message))
		{	
 
		if ($erreur_message <> "")
			{
			    $erreur_message=str_replace("\n",'<br />',$erreur_message) ;
   				$template->assign('errors',$erreur_message);
				$erreur_message="";
			}
  		}
		
	
  if (isset($infos_message))
		{	
		
		if ($infos_message <> "")
			{
				$infos_message=str_replace("\n",'<br />',$infos_message) ;
   				$template->assign('infos',$infos_message);
				$infos_message="";
			}
  		}
				
		
		
}



//=================================================================================
function Get_Datas()
{
ob_start();

	$data=Lire_datas();


	  	  	$m= ob_get_contents();
    	ob_end_clean();
	
	if (strlen($m)>0) {
	vrif_base() ;
	$data=Lire_datas();
	}
    return $data;
}

function Lire_datas()
{
global $period_search,$period_match ;
 $query = "
    SELECT *
    FROM ".MAIL_SUPERV_TABLE."
  	;";
    $data = mysql_fetch_array(pwg_query($query));
	//====================================================================================
	

    $mails_periode="+".str_replace($period_search, $period_match, $data['nb_mails_periode']);
	$next_day =  strtotime(  $mails_periode,$data['date_mail']);
	$data['rest_mail']=  ( $next_day )-time() ;
	
				
	$spams_periode="+".str_replace($period_search, $period_match, $data['nb_spams_periode']);
	$next_day =  strtotime(  $spams_periode,$data['date_spam']);
	$data['rest_spam']=  ( $next_day )-time() ;

  
	$quarantaine_periode="+".str_replace($period_search, $period_match, $data['quarantaine_periode']);
	$next_day =  strtotime( $quarantaine_periode,$data['date_quarantaine']);	
	if ($data['quarantaine']) {
	$data['reste'] =   ( $next_day )-time() ;
	}else{
	$data['reste'] = 0;
	}
	
	 return $data;
}

//=================================================================================
function corrige_header($Carbonne,$headers)
	{
	global $mails_options,$conf_mail,$mailto;

		$splitter="|".$Carbonne.":(.*)\n|U";
		preg_match_all($splitter,$headers, $out,PREG_PATTERN_ORDER);
		$val=array();
		$match=array("<",">");
		$string=array("","") ;
		foreach($out as $messages)
		{
		$val[]=  $messages[0] ;
		}
 

	$val[1]=  str_replace( $match,$string,$val[0] ) ;
	$src=$val[0];
	
	$splitter="|\"(.*)\"|U";
	preg_match_all($splitter,$val[1], $out,PREG_PATTERN_ORDER);
	$string=array();
	$string = array_fill( 0, count($out), '');
	$dest = str_replace($out[0], $string, $val[1]) ;
 if ($mailto <>"" ) {	
	 $dest=str_replace($mailto.',', '', $dest) ;
	 $dest=str_replace($mailto, '', $dest) ;
	
} 


	$headers = str_replace( $src,$dest, $headers) ;
	return $headers;

		
	}
	
function int_to_heure($int)
{
$week= (int) ($int/(3600*24*7)); 
$int=$int-($week*(3600*24*7));  

$day= (int) ($int/(3600*24));   
$int=$int-($day*(3600*24));

$heures=(int) ($int/3600);

$int=$int-($heures*(3600));

$minutes=(int) ($int/60);
$int= $int - ($minutes*(60));

$secondes=(int) ($int);

$heures= substr ('00'. $heures,-2,2);   
$day= substr ('00'.  $day,-2,2);   
$minutes=substr ('00'.$minutes,-2,2);
$secondes=substr ('00'.$secondes,-2,2);

if ($week > 0 )
{

return $week. " " .l10n('Week'). " " .  $day . " " .l10n('Day'). "s ". $heures . " ". l10n('Hour'). "s " . $minutes. " " .l10n('minute'). "s ".  $secondes." " .l10n('seconde')."s";
}
return $day . " " .l10n('Day'). "s ". $heures . " ". l10n('Hour'). "s " . $minutes. " " .l10n('Minute'). "s ".  $secondes." " .l10n('Seconde')."s";

}	

function memo_var($variables)
{
   		ob_start();
		echo '<pre>';
		print_r($variables);
		echo '</pre>';
 	  	$m= ob_get_contents();

    	ob_end_clean();
		return $m;
		
}

function vrif_base()
{

$q = "
    CREATE TABLE IF NOT EXISTS ".MAIL_SUPERV_TABLE." (
		`id` SMALLINT( 5 ) NOT NULL DEFAULT '0',
		
		`nb_mails` INT NOT NULL DEFAULT '0',
		`date_mail` INT NOT NULL DEFAULT '0',
		`nb_mails_maxi` INT NOT NULL DEFAULT '2000',		
		`nb_mails_periode` TEXT  ,	
		
		`nb_spams` INT NOT NULL DEFAULT '0',
		`date_spam` INT NOT NULL DEFAULT '0',	
		
		`nb_spams_maxi` INT NOT NULL DEFAULT '10',	
		`nb_spams_periode` TEXT  ,	
		
		`quarantaine` TEXT NOT NULL ,
		`date_quarantaine` INT NOT NULL DEFAULT '0',
		`quarantaine_periode` TEXT  ,	
			
		
		`message` TEXT NOT NULL , 
		`header_text` TEXT NOT NULL , 
      	PRIMARY KEY  (`id` )
   	 )
  ;";
  pwg_query($q);
  
    $nb = Get_colonnes_de(MAIL_SUPERV_TABLE);
	$table=$nb[MAIL_SUPERV_TABLE];	 
//================================================================================	
    if (!in_array( "nb_mails",$table)) {	
		$query = "ALTER TABLE `".MAIL_SUPERV_TABLE."` ADD `nb_mails` INT NOT NULL default '0' ";
			   pwg_query($query);            }  
	if (!in_array( "date_mail",$table)) {	
	  $query = "ALTER TABLE `".MAIL_SUPERV_TABLE."` ADD `date_mail` INT NOT NULL default '0' ";
			   pwg_query($query);            } 
	if (!in_array( "nb_mails_maxi",$table)) {	
	  $query = "ALTER TABLE `".MAIL_SUPERV_TABLE."` ADD `nb_mails_maxi` INT NOT NULL default '2000' ";
			   pwg_query($query);            } 
	if (!in_array( "nb_mails_periode",$table)) {	
	  $query = "ALTER TABLE `".MAIL_SUPERV_TABLE."` ADD `nb_mails_periode` TEXT ";
			   pwg_query($query);            } 
			   			   
			   	   		   
    if (!in_array( "nb_spams",$table)) {	
		$query = "ALTER TABLE `".MAIL_SUPERV_TABLE."` ADD `nb_spams` INT NOT NULL default '0' ";
			   pwg_query($query);            }  
	if (!in_array( "date_spam",$table)) {	
	  $query = "ALTER TABLE `".MAIL_SUPERV_TABLE."` ADD `date_spam` INT NOT NULL default '0' ";
			   pwg_query($query);            } 			   
			    
    if (!in_array( "nb_spams_maxi",$table)) {	
		$query = "ALTER TABLE `".MAIL_SUPERV_TABLE."` ADD `nb_spams_maxi` INT NOT NULL default '10' ";
			   pwg_query($query);  
	if (!in_array( "nb_spams_periode",$table)) {	
	  $query = "ALTER TABLE `".MAIL_SUPERV_TABLE."` ADD `nb_spams_periode` TEXT ";
			   pwg_query($query);            } 			             }  
			   				
		if (!in_array( "quarantaine",$table)) {	
	  $query = "ALTER TABLE `".MAIL_SUPERV_TABLE."` ADD `quarantaine` TEXT NOT NULL , ";
			   pwg_query($query);            } 	
			   
		if (!in_array( "date_quarantaine",$table)) {	
	  $query = "ALTER TABLE `".MAIL_SUPERV_TABLE."` ADD `date_quarantaine` INT NOT NULL default '0'    ";
			   pwg_query($query);   
 			            } 	
		if (!in_array( "quarantaine_periode",$table)) {	
	  $query = "ALTER TABLE `".MAIL_SUPERV_TABLE."` ADD `quarantaine_periode` TEXT ";
			   pwg_query($query);            } 					   
			   	
		if (!in_array( "message",$table)) {	
	  $query = "ALTER TABLE `".MAIL_SUPERV_TABLE."` ADD `message` TEXT   ";
			   pwg_query($query);            } 	
			   
		if (!in_array( "header_text",$table)) {	
	  $query = "ALTER TABLE `".MAIL_SUPERV_TABLE."` ADD `header_text` TEXT   ";
			   pwg_query($query);            } 		
		   			    			   	
		   			    
      $query = "
    		SELECT COUNT(*)
    		FROM ".MAIL_SUPERV_TABLE."
  		;";
//==============================================================================		
  list($count) = mysql_fetch_row(pwg_query($query));
  if ($count == 0)
  {
	 $next_day = time()  ;
	 $date_quarantaine=time();
	   $q = '
    INSERT INTO '.MAIL_SUPERV_TABLE.' (id,
	nb_mails,date_mail,nb_mails_maxi,nb_mails_periode,
	nb_spams,date_spam,nb_spams_maxi,nb_spams_periode,
	 quarantaine, date_quarantaine,quarantaine_periode,
	 message,header_text)
    VALUES (1,
	0,
	'.time().',
	2000,
	"1 week",
	
	0,
	'.time().',
	10,
	"2 day",
	
	false,
	'.time().',
	"2 day",
	
	"Init.",
	 "'.l10n('hello').'"
	 )
 	 ;';


	pwg_query($q);
	
 	} 
}
function Get_colonnes_de($table)
{
  $columns_of = array();
    $query = 'DESC '.$table.';';
    $result = mysql_query($query);
    $columns_of[$table] = array();
    while ($row = mysql_fetch_row($result))
    {
      array_push($columns_of[$table], $row[0]);
    }
  return $columns_of;
}

function test_envoie()
{
global $infos_message,$erreur_message ,$conf,$user ;


//$infos_message=memo_var($user);

$admins = array();
  $query = '
select
  U.'.$conf['user_fields']['username'].' as username,
  U.'.$conf['user_fields']['email'].' as mail_address
from
  '.USERS_TABLE.' as U,
  '.USER_INFOS_TABLE.' as I
where
  I.user_id =  U.'.$conf['user_fields']['id'].' and
  I.status in (\'webmaster\',  \'admin\') and
  I.adviser = \'false\' and
  '.$conf['user_fields']['email'].' is not null and
  I.user_id <> '.$user['id'].'
order by
  username
';
//==================================================================================

  $datas = pwg_query($query);
  
  
  if (!empty($datas))
  {
    while ($admin = mysql_fetch_array($datas))
    {
      if (!empty($admin['mail_address']))
      {
     	array_push($admins, format_email($admin['username'], $admin['mail_address']));
	
      }
    }
  }

  if (count($admins) > 0)
  {
  
  ob_start();
  	$erreur_message ="";
 // 	$infos_message .=   memo_var($admins);
	

	  
 //===========================================================
  	$args = array();
  	$args['Bcc']=$admins;
  	$message_texte="Bonjour.";
  	$message_html="Test";
/*
 	$limite = "_parties_".generate_key(32);; 
 //	$limite=$conf_mail['boundary_key'];
  		$nom ='piwigo_logo_sombre_214x100.png'; 
		$typemime='image/jpeg';

  $attachement = "-----=".$limite."\n"; 
  $attachement .= "Content-Type: ".$typemime."; name=\"".$nom."\"\n"; 
  $attachement .= "Content-Transfer-Encoding: base64\n"; 
  $attachement .= "Content-Disposition: attachment; filename=\"".$nom."\"\n\n"; 
  $fd = fopen( $fichier, "r" ); 
  $contenu = fread( $fd, filesize( $fichier ) ); 
  fclose( $fd ); 
  $attachement .= chunk_split(base64_encode($contenu)); 
  $attachement .= "\n\n\n-----=".$limite."\n"; 
  */
 //==========================================================================

 $args['subject']="Plugin Piwigo TEST";
 $args['content']="TEST ";
 
	  $infos_message .="ARGUMENTS.".memo_var($args);
   $infos_message .="TEST ENVOIE [admin].".memo_var($admins);

        $ret= pwg_mail( "", $args); 
  	  	$m= ob_get_contents();
    	ob_end_clean();
		$erreur_message .=$m;
	}
}

?>